/* this works (for LJ), uses a dix-loop */

static double linkcell(linklist_t ****list) /******************** linkcell */
{
  double U=0;
  int ith,dix;
  int maxdix=2+(int)((box.cutoff-1e-5)/(box.L[0]/No.cell[0]));
  int forceserial=measure && No.measureserial; /* should never happen */
  pll_global_t *pll_global; /* array [No.cell[0]] */

  if (No.c) {
    max14=0;
    if (box.excrlimit==0) excrrlimit=Sqr(box.cutoff);
    else excrrlimit=Sqr(box.excrlimit); }

  if (No.th<1 || No.th>No.cell[0]) ERROR(("invalid number of No.th"))

  allocarrayzero(pll_global,No.th);

  loop (dix,0,maxdix) {
    if (forceserial) {
      /* cannot execute in parallel (leftover - should never happen) */
      loop (ith,0,No.th) {
        par1_lc.by=No.th;
        par1_lc.dix=dix;
        par1_lc.list=list;
        par1_lc.glob0=pll_global;
        pll_linkcell(No.thread+ith);
      } }
    else
      par1_lc.by=No.th;
      par1_lc.dix=dix;
      par1_lc.list=list;
      par1_lc.glob0=pll_global;
      PARALLELIZE(pll_linkcell,No.th)
  } /* end of dix loop */

  /* sum up all instances of En.el, En.vir ... */
  if (measure) loop (ith,0,No.th) {
#if PRESSURETENSOR&PT_VIR
    loop (dix,0,PT_DIM) En.Pvir[dix]+=pll_global[ith].Pvir[dix];
#endif
    U += pll_global[ith].U;
    En.el += pll_global[ith].Enel;
    En.vir += pll_global[ith].Envir; }

  if (partimes.rspace) loop (ith,0,No.th)
    partimes.rspace[ith]+=pll_global[ith].t/(double)CLOCKS_PER_SEC;

  loop (ith,0,No.th) Max(max14,pll_global[ith].max14)

  free(pll_global);

  if (No.c) update14();

  return U;
} /* linkcell */
