/* make plot
 */

void help(void)
{
  if (getmaxx()<639 || getmaxy()<479) selectfont(0); else selectfont(2);
  dathelp=xfont.height+1;
  athelp=5;

  setwritemode(0);
  clearviewport();
  settextjustify(0,2);

  erasebuttons();
  makebutton(getmaxx()-xfont.width*9-3,5,F1,"exit help","return back to main menu\nhotkey=[F1] or [ESC]..");

 LMENU:
  H("=== GUI MENU ===","                     [plot V"VERSION" (c) J. Kolafa]");
  H("F10;\22","GUI menu on/off (darker and shifted if menu off)");
  H("right click                         ;button","show context help on the         clicked");
  H("","- each GUI button is equivalent to a hot hey");
  H("","- some hot keys are not available as buttons");

  athelp+=xfont.height/2;
  H("=== QUIT ===","");
  H("ESC q","type twice to quit \'plot\'");
  H("Ctrl-Q Q;quit","   quit  \'plot\'immediately");
  athelp+=2;
  H("K;kill all","kill all plots started by showcp or rdfg");
  athelp+=2;
  H("K;KILL ALL","kill all plots by \'killall plot\'");
  H("","(if enabled by K in environment variable GUI)");

  athelp+=xfont.height/2;
  H("=== MOUSE ===","");
  H("left click","digitize: print x y, on 2nd click also dx dy");
  H("mid click","print x,y in pt, useful in \"plot.eps\",\"ps.def\"");
  H("","left+mid: if TOCLIP then copy to the clipboard");
  H("right click","show file and parameter info");
  H("left drag","rectangle to zoom in");
  H("mid drag","move the graph (panning)");
  H("right drag","rescale graph");
  H("wheel","rescale graph in the y-axis");
  NEXTPAGE(LMENU,LMENU)

 LSCALE:
  H("=== SCALING ===","");
  H("+ -","zoom in/out both axes");
  H("x X","zoom in/out x-axis");
  H("y Y","zoom in/out y-axis");
  H("Ctrl-X;x","center around x=0");
  athelp+=2;
  H("Ctrl-Y;y","center around y=0");
  H("cursors","move viewpoint (also middle mouse panning)");
  H("R","round the axes up to int-multiples of powers of 10");
  H("Ctrl-R","round the axes to int-multiples of powers of 10");
  H("Ctrl-Z;undo","undo last zoom (also hotkey=[u])");
  H("k;init","initial zoom (also hotkey=[U])");
  athelp+=xfont.height/2;
  H("=== FILES ===","");
  H("r","reread files and redraw");
  H("Ins","show file and parameter info (also right click)");
  H("Del","remove file and parameter info");
  H("PgUp PgDn","cycle through files (if FILE contains int format)");
  H("{ }","as above");
  NEXTPAGE(LMENU,LSCALE)

 LSTYLE:
  H("=== PLOT STYLE ===","");
  H("The following function apply only if the draw style","");
  H("is not set from the command line, or key s in STYLE:","");
  athelp+=2;
  H("SPACE;style","toggle 3 styles: lines, points, lines+points");
  H(":;...","draw by dotted line");
  H("\\    ;---","draw by solid line");
  H("l L","cycle through line styles (dotted/normal/thick/thicker..)");
  H(".;points","draw points as pixels (smallest dots)");
  H("p P","change dot sizes");

  athelp+=xfont.height/2;
  H("=== MORE ===","");
  H("[ ]","change the column to plot on Y-axis, scale unchanged");
  H("",   "good for commands as \'plot FILE:1:3\' or \'plot FILE:A:C\'");
  H("",   "More precisely: ASCII code of the 1st char in the Y-field");
  H("",   "is changed; e.g., plot -:A:a+B \32 plot -:A:b+B");
  H("1 2 .. 9","select the column to plot on y-axis (column<10)");
  H("010 .. 099","select the column to plot on y-axis (10<=column<100)");
  H("z Z;grid","cycle through grid styles (none, dense, thin)");
  H("F5 Ctrl-O;font"," ");
  H("","toggle font size (small/large)");
  NEXTPAGE(LSCALE,LSTYLE)

  LDUMP:
   H("=== OUTPUT ===","");
   H("#;EPS","export plot.eps/plot.ps, use settings from ps.def:");
   H("","for more info, see \".../macsimus/examples/ps.def\"");

   athelp+=xfont.height/2;
   H("P Ctrl-P","[PrtScr] dump screen in various formats");
   H("then select 2nd key:","");
   H(" P",  "dump screen in the PPM (Portable PixMap, P6) format");
   H(" p",  " as above, white background, some colors changed");
   H(" E",  "dump screen in the EPS format");
   H(" e",  " as above, white background, some colors changed");
   H(" C",  "dump screen in the PS format, on A4");
   H(" c",  " as above, white background, some colors changed");
   H(" O",  "dump screen in gray in the PS format, on A4");
   H(" o",  " as above, white background, some colors changed");
  NEXTPAGE(LSTYLE,LDUMP)

    LPARMS:
#if PARM
  H("=== PARAMETERS ===","");
  H("There are 10 parameters denoted a,b,c,d,e,f,g,h,i,j","");
  H("available in formulas and as shell variables.","");
  H("Info on parameter not present in formulas is in gray","");
  H("See also environment variable PLOTCMD","");
  H("Example:","a=2 plot \"[0:99]\" \"[999]:x:sin(x+a)\"");
  H("   ;a","button to get slider for parameter a");
  H("following functions also recenter the slider:","");
  H("a;<","decrease the value of parameter a by step");
  H("A  ;>","increase the value of parameter a by step");
  H("*;*","double the step for changing the active parameter");
  H("/  ;/","halve the step for changing the active parameter");
  H("Ctrl-A ;=0","set parameter a/active parameter to 0");
  H("< o >","as [a] [Ctrl-A] [A] for the active parameter");
  H("F8;all0","erase all parameters");
  athelp+=xfont.height/2;
  H("v","print x,y ranges and active variables");
  H("V","export active variables to plotenv.sh");
  H("","(can be read to sh or bash by \". plotenv.sh\")");
  athelp+=xfont.height/2;
  H("=","switch to the terminal and enter data from keyboard");
  H("","(with help)");
#else
  H("not available in this version","");
#endif /*# PARM */
  NEXTPAGE(LSCALE,LPARMS)

    LFIT:
  H("=== FITTING ===","");
#if PARM
  H("Example:","plot FILE \":a+b*A\"");
  H("For more help, run plot without arguments and select t as fi(t)","");
  H("See also environment variable INTEG","");
  athelp+=2;
  H("t;std","fit the data to the function, long double (recommended)");
  athelp+=2;
  H("T;high","fit the data to the function, emulated high precision");
  H("Ctrl-T;fast","fit the data to the function, double");
  H("n N","decrease/increase the number of sampling points");
  H("","to calculate standard uncertainties of parameters");
  H(" ;0","no uncertainties calculated");
  H("   ;128","button to set the number of sampling points");
  athelp+=2;
  H("=","switch to the terminal and enter data from keyboard");
  H("","(with help)");
#else
  H("not available in this version","");
#endif
  NEXTPAGE(LPARMS,LFIT)

 LMACRO:
  H("=== MACROS ===","");
  H("`",      "macro and repeat prefix");
  H("--- syntax ---","");
  H("`A@@@@`","define macro A, @@@@ = max 31 ASCII characters");
  H("",       "mouse movement not supported in macro");
  H("",       "26 macros A..Z are available");
  H("`A`",    "erase macro A (=replace by empty string)");
  H("`Ctrl-A","print macro to stderr (simple)");
  H("`a",     "execute macro A");
  H("`####@", "repeat character @ ####-times (max 9999)");
  H("`####`a","repeat macro A ####-times");
  H("ESC",    "interrupt running macro");
  H("--- example ---","");
  H("`AaB`","define `a as: decrease parm a, increase b");
  H("`60`a",  "execute `a 60x");
  NEXTPAGE(LFIT,LMACRO)

  goto LMACRO;
}
