/* make plot
 */
void prtsfill(char *s)
{
  char *c;
  int n=0;

  for (c=s; *c; c++) n+=*c=='\n';

  while (n++<22) _n

  prts(s);
}

#include "guihlp.c"

static char Phelp[]="\
More help: (i)ntro  (o)ptions  (e)nvironment  (r)ange  (f)iles  (c)olumns\n\
           (s)tyle  co(l)ors   e(x)pressions  (p)rint  fi(t)    (g)ui\n\
";

static char Pusage[]="\
PLOT V"VERSION": MACSIMUS command-line plot.  Call by:\n\
\n\
  plot [OPTIONS] [RANGE] [FILE][COLUMNS] [[FILE][COLUMNS] ..]\n\
\n\
Important hotkeys:\n\
  [F1]=help   [F10]=menu on/off   RightClick menu button=help\n\
\n\
See also:\n\
  tabproc tab ev evu field mergetab psstring\n\
\n\
Examples:\n\
  Plot a file of 2 columns (x,y):\n\
    plot data.dat\n\
  Plot a function:\n\
    plot \'[0:6.28]\' \'[111]:x:sin(x)\'\n\
  Plot several files containing 3 columns (N,VAL,ERR) as 1/N vs. VAL+-ERR,\n\
  enhance the 1/N -> 0 limit by adding a/N (adjust a by button [a] or a A / *):\n\
    plot \"[0:]\" \":1/A:B+a/A:-o:C\" data1.dat data2.dat ..\n\
  Fit data.dat (three columns, with errors) to a+b*A+c*A^2:\n\
    plot data.dat:A:B:o:C \"[111]:A:a+b*A+c*A^2:-:\"\n\
";

static char Poptions[]="\n\
OPTIONS must precede any other argument. OPTIONS apply globally.\n\
No space before the argument. OPTIONS not allowed in @RESPONSEFILE.\n\
\n\
  -ISTRING\n\
      Initial keystroke; e.g., -I#Q will print EPS and quit plot.\n\
      (Overrides environment variable PLOTINIT)\n\
  -gGEOMETRY\n\
      Initial X geometry (default=824x480+1+1 or less on a small screen)\n\
      (Overrides environment variable PLOTGEOMETRY)\n\
  -hFROM\n\
      Initial number for FORMAT (file name with int format, see (f)iles)\n\
  -kKEY or -fKEY\n\
      Plot only lines containing string KEY\n\
      Lines without KEY are treated as blank (even if comment)\n\
  -n or -c\n\
      Blank line in a file causes color to be advanced by 1;\n\
      i.e., blank-separated blocks of data are drawn by different colors.\n\
      (Also char `n' in the style field)\n\
  -sDELAY or -dDELAY\n\
      Slow: DELAY (real number in seconds) and XFlush added after each point.\n\
";

static char Prange[]="\n\
RANGE = [FROMX:TOX,FROMY:TOY] or [FROMX:TOX][FROMY:TOY]\n\
        [FROMX:TOX] = shortcut for [FROMX:TOX][:]\n\
        [:] = the same as missing at all\n\
Brackets [] are included in the RANGE\n\
\n\
Incomplete ranges (e.g., [0:][0:]) mean that the missing bounds will be\n\
determined from FILEs.\n\
At most one RANGE argument is accepted, between OPTIONS and FILES\n\
\n\
Example:\n\
  plot \'[0:10][0:]\' data.dat\n\
";

static char Pfiles[]="\n\
FILE =\n\
  FILENAME : File to plot\n\
  - : stdin (pipe) instead of file. Example:\n\
        tail -n100 | plot -:A:C\n\
  FORMAT : FORMAT should contain a C-style format accepting integer. The value\n\
      of option -h (or 0 if not given) is substituted and the file is plotted.\n\
      The integer can be in/decremented by hotkeys { } or from menu. Example:\n\
        plot -h1 :n:E sim%04d.cpa\n\
  -NAME : do not plot (right now), yet advance colors/plotstyle as if plotted\n\
  [INT] : (incl. []) Equivalent to file of INT+1 equidistant points in the\n\
      x-interval given by parameter RANGE.\n\
  [INT:FROMX:TOX] : As above, override x-range given in RANGE. Example:\n\
        plot '[-1:1][-1:1]' '[6:0:360]:sin(PI/180*x):cos(PI/180*x)'\n\
  @ : dummy (useful to set column and plot style)\n\
  @RESPONSEFILE : read arguments from file instead from command line\n\
\n\
FILEs to plot are text files composed of white-separated columns\n\
#! denotes comment: line is interrupted (points are not connected)\n\
Empty line: a line is interrupted and counter (n = #0) is reset to 0.\n\
";

static char Pcolumns[]="\n\
COLUMNS =\n\
  :X:Y  = column numbers or expressions to plot by the previous/default STYLE\n\
  :Y    = shortcut for :previous_X:Y or :x:Y if no previous X given\n\
  :X:Y:STYLE = plot by given STYLE (see page (s)tyle)\n\
  :X:Y:STYLE:DY = shortcut for :X:Y:STYLE:DY:DY\n\
  :X:Y:STYLE:DYL:DYH = plot vertical error bars (yy style=default);\n\
                       low and high bounds may differ\n\
  :X:Y:STYLE:DXL:DXH = plot horizontal error bars (xx style)\n\
  :X:Y:STYLE:DX:DY = plot both vertical and horizontal error bars,\n\
                     low and high bounds must be the same (symmetric)\n\
\n\
Any of parameters X,Y,DX,DY.. may stand for:\n\
- column number (dec. integer), can be changed from menu or by hotkeys 0..9\n\
- column number preceded by 0 (as 01), cannot be changed\n\
- expression containing columns coded as: A,B,.. or #1,#2,.. or c1,c2,..;\n\
- x,y,z are aliases for A,B,C\n\
- column 0 = #0 = c0 = @ = n = line count (from 0), reset by blank line in file\n\
  Example (plot 1-column data): plot data.dat:0:1\n\
\n\
Missing columns are copied from previous argument, default = 1:2\n\
";

static char Pexpr[]="\n\
Expressions use common precedence rules and functions. Notable exceptions:\n\
  1/2 -> 0.5 (real) in plots\n\
  1/2 -> 0 (integer) when exported to the fitting engine (use 1./2 in doubt)\n\
  ^ = power  % = modulo  & = bitwise and  | = or  $ = xor\n\
  ** = power (in plot only, not fitting)\n\
  Comparisons < > <= >= == <> give 1=true and 0=false\n\
  ln = natural log   log = decadic log   lb = binary log\n\
  sin,cos,tan accept arg in radians, asin,acos,atan return radians\n\
  More: exp,sinh,asinh,..,erf,erfc,fac,gamma,lgamma,sign,int,floor,frac\n\
  \\=sqrt (protect \\ from shell!)\n\
Parameters:\n\
  10 parameters called a,b,..j are available and adjustable from plot,\n\
  also accessible as environment variables.n\
  Parameters can be changed from menu by slider, or by hot keys (for a):\n\
    increment by A, decrement by a, zero by Ctrl-A,\n\
    change increment by / and *\n\
MORE HINTS FOR FITTING (formulas are translated into C):\n\
  not available: xor  <>  lb  int  \\  fac  frac  ** (use ^)  pi (use PI)\n\
  often more parentheses are needed\n\
";

static char Pstyle[]="\n\
STYLE = string of characters:\n\
  Lines:  - = solid   = = thick   d = dotted\n\
  Dots:   . = pixel   p = small   P = medium   o = large   O = huge\n\
\n\
Decimal numbers code colors: 1=white,2=yellow,3=cyan..\n\
Colors are inverted on white background; see co(l)ors for more\n\
\n\
More keys:\n\
    c = the same as 1 and allow advancing color for next file\n\
   cc = the same as 2 and allow advancing color for next file...\n\
    C = keep last color\n\
    x = set xx style of error bars\n\
    y = set yy style of error bars (default)\n\
   xy = set xy style of error bars\n\
    s = enable style changes by [style] or SPACE\n\
    n = toggle interpretation of blank lines in files, see option -n\n\
\n\
- missing or empty STYLE = previous STYLE (color may be advanced by 1)\n\
- default STYLE = solid line, style changeable by [style] or SPACE\n\
- fixed style cannot be changed by [style] or SPACE unless key s given\n\
";

static char Pcolors[]="\n\
Colors are coded by decimal numbers in STYLE string:\n\
\n\
  ===============================================================\n\
    #   screen    inverted           #   screen    inverted\n\
  ---------------------------------------------------------------\n\
    1 = white     black              8 = brown     blue-cyan\n\
    2 = yellow    blue               9 = dark cyan salmon\n\
    3 = cyan      red               10 = purple    light green\n\
    4 = magenta   green             11 = gray      gray\n\
    5 = green     magenta           12 = olive     purple\n\
    6 = red       cyan              13 = dark red  light cyan\n\
    7 = blue      yellow            14 = dark blue light yellow\n\
  ---------------------------------------------------------------\n\
\n\
Colors are inverted at white background, as for EPS output.\n\
";

static char Penv[]="\n\
Environment variables:\n\
  GUI = common GUI setup, see page (g)ui\n\
  TOCLIP = command to put data into clipboard (after left/mid clicks)\n\
    -COMMAND : via pipe (example: export TOCLIP=-xclip)\n\
    COMMAND : as argument, example for KDE:\n\
      export TOCLIP=\"dcop --user $USER klipper klipper setClipboardContents\"\n\
  PLOTNAME = window, icon and exported [E]PS title name\n\
  FIT4PLOT = path to fitting support, normally .../macsimus/c/fit4plot/\n\
  a,b,..j = parameters, changeable by a A ^A, etc\n\
  astep,bstep,..,jstep = initial steps for a A etc.\n\
  aname,bname,..,jname = printed in the info panel\n\
  PLOTCMD = sh command executed before all plots\n\
            parameters a,b.. are available; e.g., \'myprog $a > file\')\n\
  INTEG = NINT[,XFROM[,XTO]], calculate the integral of fit in given range\n\
          (plot RANGE if not given), NINT=# of Gauss subintervals\n\
  PLOTGEOMETRY = widow geometry, see also option -g\n\
  PLOTINIT = initial keystroke, see also option -I\n\
";

static char Pfit[]="\n\
FITTING:\n\
  Input x,y-data in columns 1,2, optional stderr (default=1) in column 3.\n\
Object function:\n\
  sigma^2 = SUM_i { [y_i-f(a,b,..;x_i)]^2 / stderr_i^2 } / (n-np)\n\
where n=# of points, np=# of parameters.\n\
Parameters are a,b,c,..,j, consecutively\n\
Examples:\n\
  plot FILE \":a+b*A\"\n\
  plot \'[0:1]\' FILE:A:B:o:C \"[111]:A:(a+b*A^(1./3))/(1+c*A)\":-:\"\n\
Tricks:\n\
  f(a,b,..;x) is translated by C, see e(x)pressions for more info\n\
Hints:\n\
  pre-adjust values of parameters a,b,c.. by hotkeys aAbBcB/* if necessary\n\
  and fit by [std] = hotkey t, in case of problems [high] = T\n\
  standard errors of parameters by sampling: set nerr, hotkeys = nN\n\
  command-line frontend with more help: hotkey =\n\
Integral of the fit:\n\
  see (e)nvironment INTEG\n\
";

static char Pprint[]="\n\
Print output in EPS and PS formats:\n\
  - Axes, labeling etc. are set in definition file ps.def,\n\
    see the commented example .../macsimus/examples/ps.def\n\
  - Output is plot.eps (default) or plot.ps (if Landscape or Portrait)\n\
  - Use hotkey F4 or # or button [EPS]\n\
  - Use the middle button to get coordinates in pt=in/72 to be pasted to\n\
    commads l in ps.def, or to EPS as X Y moveto () show\n\
";
